#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "BOARD.h"   
#include <xc.h>
#include <plib.h>

typedef enum{BUTTON_CHANGE, SWITCH_CHANGE} event_type;
void verySlowProcess(event_type event);

char previous_switch = 0;

char previous_buttons = 0;

int main(void)
{
    BOARD_Init();
    printf("Starting blocking exaple:");

    while (1) {
        //check for switch change:
        while (previous_switch == SWITCH_STATES()); //wait for switch states to change         
        previous_switch = SWITCH_STATES();
        printf("SWITCH CHANGED\n");
        verySlowProcess(SWITCH_CHANGE);

        //check for buttons:
        while (previous_buttons == BUTTON_STATES()); //wait for switch states to change         
        previous_buttons = BUTTON_STATES();
        printf("BUTTONS CHANGED\n");
        verySlowProcess(BUTTON_CHANGE);

    }
}

void verySlowProcess(event_type event)
{    
    // <editor-fold defaultstate="collapsed" desc="very slow process here">
    int i;
    for (i = 0; i<1000000; i++);
    // </editor-fold>
    switch (event){
    case SWITCH_CHANGE:
        printf("Done handling SWITCH_CHANGE\n\n");
        break;
    case BUTTON_CHANGE:
        printf("Done handling BUTTON_CHANGE\n\n");
        break;
        
    }
}